import {Component, Inject, ElementRef, EventEmitter, HostListener} from '@angular/core';
import {IgHierarchicalGridComponent} from "../src/igniteui.angular2.ts";
import {NorthwindEmployees} from "../data/northwind-employees.ts";
import {bootstrap }    from '@angular/platform-browser-dynamic'

declare var jQuery: any;
@Component({
	selector: 'my-app',
	templateUrl: "./app/igHierarchicalGridTemplate.html",
	directives: [IgHierarchicalGridComponent]
})
export class AppComponent {
	private hgridOptions: IgHierarchicalGrid;
	private id: string;
	private data: any;
	private newProduct:any;

	constructor() {
		this.data = NorthwindEmployees.getData();

		this.id ='hgrid1';

		this.hgridOptions = {
			autoCommit:true,
			dataSource: this.data,
			width: "100%",
			height: "800px",
			autoGenerateColumns: false,
			autoGenerateColumnLayouts: false,
			primaryKey: "EmployeeID",
			columns: [
				{ key: "EmployeeID", hidden: true, dataType:"number" },
				{ key: "FirstName", headerText: "First Name", width:"25%", dataType:"string" },
				{ key: "LastName", headerText: "Last Name", width:"25%", dataType:"string" },
				{ key: "Title", headerText: "Title", width:"25%", dataType:"string" },
				{ key: "BirthDate", headerText: "Birth Date", width:"25%", dataType:"date" }
			],
			columnLayouts: [
				{
					key: "Orders",
					responseDataKey: "results",
					primaryKey: "OrderID",
					autoGenerateColumns: false,
					width: "100%",
					caption: "placeholder",
					columns: [
						{ key: "OrderID", headerText: "OrderID", width:"25%", dataType:"string" },
						{ key: "Freight", headerText: "Freight", width:"25%", dataType:"string" },
						{ key: "ShipName", headerText: "ShipName", width:"25%", dataType:"string" },
						{ key: "ShipAddress", headerText: "ShipAddress", width:"25%", dataType:"string" }
					],
					features: [
						{
							name: "Paging",
							pageSize: "10"
						}
					]
				}
			]
		};
	}

	childGridRenderedHandler(event: any) {
		const ui = event.ui;
		//	Get the parent row's data.
		const parentRecord = $(ui.owner.element).igGrid("findRecordByKey", ui.parentrow.data("id"));
		//	Set the child grid's header.
		$(ui.childgrid.element).igGrid("option", "caption", parentRecord.FirstName + " " +parentRecord.LastName);
	}
}

bootstrap(AppComponent);